<?

// ---------------------------------------------------
// load_affix()
// ---------------------------------------------------
function load_affix() {
   global $DEBUG;   

   global $ispellmode;

   global $sub_array;
   global $add_array;
   global $regexp_array;
   global $lang_array;
   global $flag_array;

   global $affix_file;

   global $normalized_word;
   global $normalized_flag;
   global $normalized_lang;

   $normalized_word=array();
   $normalized_flag=array();
   $normalized_lang=array();

   $sub_array=array();
   $add_array=array();
   $regexp_array=array();
   $lang_array=array();
   $flag_array=array();

   if ($ispellmode=='db') {
      $query="SELECT flag,lang,mask,find,repl
                FROM affix
               WHERE type='s'";

      if($DEBUG) echo $query,"<BR><HR>";

      if (!($res=query($query))) print_error_local('Query error: '.$query."\n<BR>".db_error());
 
      while ($row=fetch_row($res)) {
         $flag_array[]=trim($row[0]);
         $lang_array[]=trim($row[1]);
         $regexp_array[]=strtolower(trim($row[2]));
         $add_array[]=strtolower(trim($row[3]));
         $sub_array[]=strtolower(trim($row[4]));
      }
      free_result($res);
   } elseif ($ispellmode=='text') {
      reset($affix_file);

      while (list($lang,$file)=each($affix_file)) {
         $fd=fopen($file,"r");
         if (! $fd) {
            print ("Load affix error: cannot open file $file");
            exit_local(1);
         }

         $suffixes=0;
         while (! feof($fd)) {
            $str=strtolower(trim(fgets($fd,1024)));

            if (preg_match("/^#|^[\s\t\n\r]*$/",$str)) continue;

            if (ereg("^suffixes",$str)) {
               $suffixes=1;
               continue;
            }

            if ($suffixes != 1) continue;

            if (preg_match("/^flag[\s\t]+\*{0,1}(.):/i",$str,$param)) {
               $flag=trim($param[1]);
               continue;
            }

            if (preg_match("/^[\s\t]*([^>#]+)>[\s\t]+-([^\,\s\t]+),([^\s\t]+)/",$str,$param)) {
               $regexp=trim($param[1]);
               $add_str=trim($param[2]);
               $sub_str=trim($param[3]);

               $regexp=str_replace(" ","",$regexp);
               $add_str=str_replace(" ","",$add_str);
               $sub_str=str_replace(" ","",$sub_str);

               $flag_array[]=$flag;
               $lang_array[]=$lang;
               $regexp_array[]=$regexp;
               $add_array[]=$add_str;
               $sub_array[]=$sub_str;
            } elseif (preg_match("/^[\s\t]*([^>#]+)>[\s\t]+([^\s\t\#]+)/",$str,$param)) {
               $regexp=trim($param[1]);
               $add_str='';
               $sub_str=trim($param[2]);

               $regexp=str_replace(" ","",$regexp);
               $sub_str=str_replace(" ","",$sub_str);

               $flag_array[]=$flag;
               $lang_array[]=$lang;
               $regexp_array[]=$regexp;
               $add_array[]=$add_str;
               $sub_array[]=$sub_str;
            }
         }
         fclose($fd);
      }
   }
}

// ---------------------------------------------------
// normalize_word($word)
// ---------------------------------------------------
function normalize_word($word) {
   global $DEBUG;

   global $sub_array;
   global $add_array;
   global $regexp_array;
   global $lang_array;
   global $flag_array;

   global $normalized_word;
   global $normalized_flag;
   global $normalized_lang;

   global $final_word;
   
   for($i=0; $i<count($sub_array); $i++) {
      $sub=$sub_array[$i];
      if (strlen($word)<strlen($sub)) continue;
      
      if ($sub != '') {
         if (strcmp($sub,substr($word,strlen($word)-strlen($sub),strlen($sub)))!=0) continue;
         $temp_word=eregi_replace("$sub$",$add_array[$i],$word);
      }   

      if (eregi($regexp_array[$i],$temp_word)) {
         if ($DEBUG) echo "<font color=#a00000>Possible norm form:</font> \"$temp_word\" for \"$word\"<br><hr>\n";

         $normalized_word["$word"][]=$temp_word;
         $normalized_flag["$word"][]=$flag_array[$i];
         $normalized_lang["$word"][]=$lang_array[$i];
      }
   }

   $final_word["$word"][0]=$word;
}

// ---------------------------------------------------
// check_words()
// ---------------------------------------------------
function check_words() {
   global $DEBUG;

   global $ispellmode;
   global $spell_file;
   global $grep;

   global $final_word;
   global $normalized_word;
   global $normalized_flag;
   global $normalized_lang;

   reset ($normalized_word);
   while (list($word,$value)=each($normalized_word)) {
      for ($j=0; $j<count($value); $j++) {
         $norm_word=$normalized_word[$word][$j];
         $norm_lang=$normalized_lang[$word][$j];
         $norm_flag=$normalized_flag[$word][$j];
	 
         if ($ispellmode=='db') {
            $query="SELECT flag
                      FROM spell
                     WHERE word='$norm_word'
                       AND lang='$norm_lang'";
      
            if($DEBUG) echo $query,"<BR><HR>";
      
            if (!($res=query($query))) print_error_local('Query error: '.$query."\n<BR>".db_error());
      
            while ($row=fetch_row($res)) {
               $flag=trim($row[0]);
               if ($flag == '') continue;
               if (ereg($norm_flag,$flag)) $final_word[$word][]=$norm_word;
            }
            free_result($res);
         } elseif ($ispellmode=='text') {
            reset ($spell_file);
            while (list($lang,$lang_file)=each($spell_file)) {
               if ($lang != $norm_lang) continue;
               for ($i=0;$i<count($lang_file);$i++) {
                  $file=$lang_file[$i];
                  $pipe="$grep -i ^$norm_word/ $file";
                  if ($DEBUG) echo $pipe."<br><hr>";
   
                  $fd=popen($pipe,"r");
   
                  if (! $fd) {
                     print "Cannot pipe to $grep<br>\n";
                     exit_local(1);
                  }
   
                  while (! feof($fd)) {
                     $str=trim(strtolower(fgets($fd,1024)));
                     if ($str=='') continue;
                     $str_array=explode("/",$str);
		    
                     if (($str_array[0]==$norm_word)&&
                         (ereg($norm_flag,$str_array[1])))  {
                            $final_word[$word][]=$norm_word;

                            if ($DEBUG) echo "<font color=#0000d0>Norm form found:</font> \"$norm_word\" for \"$word\"<br><hr>\n";
                     }
                  } // while
   
                  pclose($fd);
               } // for
            }
         } // if
      } // for
   } // while
}

?>

